VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Sprite"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Dim Tiles() As Tile
Public height As Integer
Public width As Integer
Dim Pal(0 To 15) As Long

Private Sub Class_Initialize()
'Here, you have to load the palette's from the ROM, this is just a test palette
Pal(0) = RGB(0 * 4, 0 * 4, 0 * 4) ' Color 0
Pal(1) = RGB(60 * 4, 60 * 4, 60 * 4) ' Color 1
Pal(2) = RGB(50 * 4, 50 * 4, 50 * 4) ' Color 2
Pal(3) = RGB(36 * 4, 40 * 4, 32 * 4) ' Color 3, and so forth...
Pal(4) = RGB(0 * 4, 40 * 4, 32 * 4)
Pal(5) = RGB(0 * 4, 32 * 4, 28 * 4)
Pal(6) = RGB(20 * 4, 28 * 4, 24 * 4)
Pal(7) = RGB(60 * 4, 44 * 4, 36 * 4)
Pal(8) = RGB(50 * 4, 38 * 4, 30 * 4)
Pal(9) = RGB(60 * 4, 36 * 4, 36 * 4)
Pal(10) = RGB(60 * 4, 0 * 4, 24 * 4)
Pal(11) = RGB(36 * 4, 0 * 4, 6 * 4)
Pal(12) = RGB(56 * 4, 52 * 4, 8 * 4)
Pal(13) = RGB(60 * 4, 36 * 4, 0 * 4)
Pal(14) = RGB(28 * 4, 28 * 4, 60 * 4)
Pal(15) = RGB(12 * 4, 8 * 4, 8 * 4)
End Sub

Public Sub InitUncompressed(ByVal address As Long, ByVal SetHeight As Integer, ByVal SetWidth As Integer)
Dim i As Integer
Dim x As Integer
Dim y As Integer
Dim tmpByte As Byte
Dim FinalString As String
Dim tmpTiles() As Tile

width = SetWidth - 1
height = SetHeight - 1

ReDim Tiles(0 To width, 0 To height)
ReDim tmpTiles(0 To ((SetHeight * SetWidth) - 1))

For i = 0 To (SetHeight * SetWidth) * 32 - 1
Get #ROMNum, address + 1 + i, tmpByte
FinalString = FinalString & ZeroCheck(Hex(tmpByte), 2)
Next i

For i = 0 To SetWidth * SetHeight - 1
    Set tmpTiles(i) = New Tile
    tmpTiles(i).Init Mid(FinalString, 1 + i * 64, 64)
Next i

For i = 0 To height
For x = 0 To width
    Set Tiles(x, i) = tmpTiles(y)
    y = y + 1
Next x
Next i

End Sub


Public Sub DrawSprite()
Dim x As Integer
Dim y As Integer
Dim i As Integer
Dim z As Integer

For x = 0 To width
For y = 0 To height
For i = 0 To 7
For z = 0 To 7
    Form1.pctColor.BackColor = Pal((Tiles(x, y).GetPixel(i, z)))
    BitBlt Form1.pctMain.hdc, (x * 8) + i, (y * 8) + z, 1, 1, Form1.pctColor.hdc, 0, 0, SRCCOPY
Next z
Next i
Next y
Next x
StretchBlt Form1.pctMain.hdc, 0, 0, 128, 128, Form1.pctMain.hdc, 0, 0, 32, 32, SRCCOPY
End Sub





'Public Sub InitCompressed(ByVal address As Long, ByVal SetWidth As Integer, ByVal SetHeight As Integer)
'Dim FinalString As String
'Dim tmpByte As Byte
'Dim tmpByte2 As Byte
'Dim Code As Byte
'Dim i As Integer
'Dim x As Integer
'Dim y As Integer
'Dim CurrentByte As Integer
'Dim tmpTiles() As Tile
'width = SetWidth - 1
'height = SetHeight - 1
'ReDim Tiles(0 To width, 0 To height)
'ReDim tmpTiles(0 To SetWidth * SetHeight - 1)
'Do Until tmpByte = &HFF
'    Get #ROMNum, address + CurrentByte + 1, tmpByte
'    Code = (tmpByte And &HE0)
'    x = (tmpByte And &H1F) + 1
'    CurrentByte = CurrentByte + 1
'Start:
'If Code <= 3 Then
'Select Case Code
'    Case 0
'        i = CurrentByte + x + 1
'        Do Until CurrentByte = i
'            Get #ROMNum, address + CurrentByte + 1, tmpByte
'            FinalString = FinalString & ZeroCheck(Hex(tmpByte), 2)
'            CurrentByte = CurrentByte + 1
'        Loop
'    Case 1
'        i = CurrentByte + x
'        Get #ROMNum, address + CurrentByte + 1, tmpByte
'        CurrentByte = CurrentByte + 1
'        For i = 1 To x
'            FinalString = FinalString & ZeroCheck(Hex(tmpByte), 2)
'        Next i
'    Case 2
'        Get #ROMNum, address + CurrentByte + 1, tmpByte
'        CurrentByte = CurrentByte + 1
'        Get #ROMNum, address + CurrentByte + 1, tmpByte2
'        CurrentByte = CurrentByte + 1
'        For i = 1 To x
'            FinalString = FinalString & ZeroCheck(Hex(tmpByte), 2)
'            FinalString = FinalString & ZeroCheck(Hex(tmpByte2), 2)
'        Next i
'    Case 3
'        Get #ROMNum, address + CurrentByte + 1, tmpByte
'        CurrentByte = CurrentByte + 1
'        For i = 1 To x
'            FinalString = FinalString & ZeroCheck(Hex(tmpByte + (i - 1)), 2)
'        Next i
'End Select
'Else
'Get #ROMNum, address + CurrentByte + 1, tmpByte
'CurrentByte = CurrentByte + 1
'Get #ROMNum, address + CurrentByte + 1, tmpByte2
'CurrentByte = CurrentByte + 1
'y = (Val("&H" & Hex(tmpByte2) & ZeroCheck(Hex(tmpByte), 2)))
'Select Case Code
'    Case 4
'        For i = 0 To x - 1
'            FinalString = FinalString & ZeroCheck(Mid(FinalString, y * 2 + i * 2, 2), 2)
'        Next i
'    Case 5
'        For i = 0 To x - 1
'            FinalString = FinalString & ZeroCheck(Hex(Bin2Dec(StrReverse(Dec2Bin(Val("&H" & ZeroCheck(Mid(FinalString, i * 2, 2), 2)))))), 2)
'        Next i
'    Case 6
'        For i = 0 To x - 1
'            FinalString = FinalString & ZeroCheck(Mid(FinalString, y * 2 - i * 2, 2), 2)
'        Next i
'    Case 7
'        Code = x And &H1C
'        Get #ROMNum, address + CurrentByte + 1, tmpByte
'        CurrentByte = CurrentByte + 1
'        x = (x And 3) * 256 + tmpByte + 1
'        GoTo Start
'End Select
'End If
'Loop
'
'For i = 0 To SetWidth * SetHeight - 1
'    Set tmpTiles(i) = New Tile
'    tmpTiles(i).Init Mid(FinalString, 1 + i * 64, 64)
'Next i
'y = 0
'For i = 0 To height
'For x = 0 To width
'    Set Tiles(x, i) = tmpTiles(y)
'    y = y + 1
'Next x
'Next i
'End Sub

